require 'uu/os/rest/dto'

module UU
  module OS
    module REST

      # The basic implementation that could be extended by DTOs used as uuCommand
      # arguments. It is used to simplify realization of uuCommands.
      class PagingCriteria < UU::OS::REST::DTO

        # Result list page index.
        # @param [Numeric]
        # @return [Numeric]
        attr_accessor :page_index

        # Result list page size.
        # @param [Numeric]
        # @return [Numeric]
        attr_accessor :page_size

        # The UES query string. It has to conform the UES query syntax (see documentation for more info).
        # Filtering and order of the result list can be specified there. When null is set, no filtering
        # is applied and entries are ordered by name and code as the second criteria.
        # @param [String]
        # @return [String]
        # @private
        attr_accessor :query

        def page_index
          attributes[:pageIndex]
        end

        def page_index=(val)
          attributes[:pageIndex] = val
        end

        def page_size
          attributes[:pageSize]
        end

        def page_size=(val)
          attributes[:pageSize] = val
        end

        def query
          attributes[:query]
        end

        def query=(val)
          attributes[:query] = val
        end

      end

    end
  end
end
